#pragma once

/*
 * Temperature Converter Sample C++ managed language version
 * 
 * Copyright 2002~2003 Marco Savegnago msave@tin.it
 * 
 */


namespace TempConverter
{
	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;

	/// <summary> 
	/// Summary for FormTempConverter
	///
	/// WARNING: If you change the name of this class, you will need to change the 
	///          'Resource File Name' property for the managed resource compiler tool 
	///          associated with all .resx files this class depends on.  Otherwise,
	///          the designers will not be able to interact properly with localized
	///          resources associated with this form.
	/// </summary>
	public __gc class FormTempConverter : public System::Windows::Forms::Form
	{	
	public:
		FormTempConverter(void)
		{
			InitializeComponent();
		}
  
	protected:
		void Dispose(Boolean disposing)
		{
			if (disposing && components)
			{
				components->Dispose();
			}
			__super::Dispose(disposing);
		}
	private: System::Windows::Forms::TextBox *  editCelsius;
	private: System::Windows::Forms::Label *  labelCelsius;
	private: System::Windows::Forms::Label *  labelFahrenheight;
	private: System::Windows::Forms::TextBox *  editFahrenheight;

	private:
		/// <summary>
		/// Required designer variable.
		/// </summary>
		System::ComponentModel::Container * components;

		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			this->editCelsius = new System::Windows::Forms::TextBox();
			this->labelCelsius = new System::Windows::Forms::Label();
			this->labelFahrenheight = new System::Windows::Forms::Label();
			this->editFahrenheight = new System::Windows::Forms::TextBox();
			this->SuspendLayout();
			// 
			// editCelsius
			// 
			this->editCelsius->Location = System::Drawing::Point(9, 40);
			this->editCelsius->Name = S"editCelsius";
			this->editCelsius->Size = System::Drawing::Size(207, 20);
			this->editCelsius->TabIndex = 3;
			this->editCelsius->Text = S"";
			this->editCelsius->KeyPress += new System::Windows::Forms::KeyPressEventHandler(this, cbcheck_KeyPress);
			this->editCelsius->TextChanged += new System::EventHandler(this, cbCelsius_TextChanged);
			this->editCelsius->Enter += new System::EventHandler(this, cbCelsius_Enter);
			// 
			// labelCelsius
			// 
			this->labelCelsius->Font = new System::Drawing::Font(S"Arial", 8.25F, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, (System::Byte)0);
			this->labelCelsius->Location = System::Drawing::Point(8, 16);
			this->labelCelsius->Name = S"labelCelsius";
			this->labelCelsius->Size = System::Drawing::Size(48, 16);
			this->labelCelsius->TabIndex = 4;
			this->labelCelsius->Text = S"Celsius";
			// 
			// labelFahrenheight
			// 
			this->labelFahrenheight->Font = new System::Drawing::Font(S"Arial", 8.25F, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, (System::Byte)0);
			this->labelFahrenheight->Location = System::Drawing::Point(8, 72);
			this->labelFahrenheight->Name = S"labelFahrenheight";
			this->labelFahrenheight->Size = System::Drawing::Size(80, 16);
			this->labelFahrenheight->TabIndex = 5;
			this->labelFahrenheight->Text = S"Fahrenheight";
			// 
			// editFahrenheight
			// 
			this->editFahrenheight->Location = System::Drawing::Point(8, 96);
			this->editFahrenheight->Name = S"editFahrenheight";
			this->editFahrenheight->Size = System::Drawing::Size(208, 20);
			this->editFahrenheight->TabIndex = 6;
			this->editFahrenheight->Text = S"";
			this->editFahrenheight->KeyPress += new System::Windows::Forms::KeyPressEventHandler(this, cbcheck_KeyPress);
			this->editFahrenheight->TextChanged += new System::EventHandler(this, cbFahrenheight_TextChanged);
			this->editFahrenheight->Enter += new System::EventHandler(this, cbFahrenheight_Enter);
			// 
			// FormTempConverter
			// 
			this->AutoScaleBaseSize = System::Drawing::Size(5, 13);
			this->ClientSize = System::Drawing::Size(226, 128);
			this->Controls->Add(this->editFahrenheight);
			this->Controls->Add(this->labelFahrenheight);
			this->Controls->Add(this->labelCelsius);
			this->Controls->Add(this->editCelsius);
			this->Font = new System::Drawing::Font(S"Arial", 8.25F);
			this->FormBorderStyle = System::Windows::Forms::FormBorderStyle::FixedDialog;
			this->MaximizeBox = false;
			this->MinimizeBox = false;
			this->Name = S"FormTempConverter";
			this->StartPosition = System::Windows::Forms::FormStartPosition::CenterScreen;
			this->Text = S".NET Temperature Converter in C++";
			this->ResumeLayout(false);

		}	




	private: 
		System::Void cbCelsius_TextChanged(System::Object *  sender, System::EventArgs *  e)
		{
			// Clear string in another textbox if there are non here
			if (editCelsius->Text->Length <= 0 || (editCelsius->Text->Length == 1 && editCelsius->Text->Equals("-")))
				editFahrenheight->Text = "";
			// Textbox is not empty
			else
			{
				// If another control is simulating the text change,
				// then do not proceed with the text conversion for this control
				if (editCelsius->Focused == false)
					return;

				// To hold our converted single precision float value
			
				float	fDegree	= 0;

				try
				{
					// Convert text string to unsigned integer
					fDegree = (float)(System::Convert::ToSingle(editCelsius->Text));
					fDegree = (fDegree * 9/5) + 32;
				}

				catch (System::OverflowException * /*exception*/) 
				{
					// Show overflow message and return
					editFahrenheight->Text = "Overflow";
					return;
				}

				catch (System::FormatException * /* exception */)
				{
					editFahrenheight->Text = "Format";
					return;
			
				}

				// Format unsigned integer value to hex and show in another textbox
				editFahrenheight->Text = fDegree.ToString();
			}
		}

	private: 
		System::Void cbFahrenheight_TextChanged(System::Object *  sender, System::EventArgs *  e)
		{
			// Clear string in another textbox if there are non here
			if (editFahrenheight->Text->Length <= 0 || (editFahrenheight->Text->Length == 1 && editFahrenheight->Text->Equals("-")))
				editCelsius->Text = "";

			// Textbox is not empty
			else
			{
				// If another control is simulating the text change,
				// then do not proceed with the text conversion for this control
				if (editFahrenheight->Focused == false)
					return;

				// To hold our converted single precision float value
				float fDegree = 0;

				try
				{
					// Convert hex string to unsigned integer
					fDegree = (float)(System::Convert::ToSingle(editFahrenheight->Text));
					fDegree	= (fDegree - 32) * 5 / 9;
				}
				
				catch (System::OverflowException * /*exception*/) 
				{
					// Show overflow message and return
					editCelsius->Text = "Overflow";
					return;
				}

				catch (System::FormatException * /* exception */)
				{
					editCelsius->Text = "Format";
					return;
				}
				
				// Format it and show as a string
				editCelsius->Text = fDegree.ToString();
			}

		}

	private: 
		System::Void cbcheck_KeyPress(System::Object *  sender, System::Windows::Forms::KeyPressEventArgs *  e)
		{
			// Process only digits and backspace

			e->Handled = true;
			
			if (Char::IsDigit(e->KeyChar) == true)
				e->Handled = false;

			switch(e->KeyChar)
			{
				case	'\b':
				case	'-':
				case	'.':
					e->Handled = false;
					break;
				default:
					break;
			}
		}

	private: 
		System::Void cbCelsius_Enter(System::Object *  sender, System::EventArgs *  e)
		{
			// Check if we have an "Overflow" message here, remove it
			// when we have a focus cos we are not and should not be
			// handling alphabets here.
			if (editCelsius->Text->Equals("Overflow"))
				editCelsius->Text = "";

			if (editCelsius->Text->Equals("Format"))
				editCelsius->Text	=	"";
		}


	private: 
		System::Void cbFahrenheight_Enter(System::Object *  sender, System::EventArgs *  e)
		{
			// Check if we have an "Overflow" message here, remove it
			// when we have a focus cos we are not and should not be
			// handling alphabets other than 'a' to 'f' here.
			if (editFahrenheight->Text->Equals("Overflow"))
				editFahrenheight->Text	=	"";

			if (editFahrenheight->Text->Equals("Format"))
				editFahrenheight->Text	=	"";
		}
	};
}


